Unit ALS1R1_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc;

procedure ALS1R1(var A :Array of Real; M :Integer; N :Integer;
                var B :Array of Real; var C :Array of Real);

implementation

procedure ALS1R1(var A :Array of Real; M :Integer; N :Integer;
                var B :Array of Real; var C :Array of Real);
var
I,J,K,L,II,JJ,JN,I1,J1,ISWTCH :Integer;
H,R1,R2,R3,R4,R5,R6,SUM,RMIN,RNORM :Real;
RD,RD2,DS1,DS2,DMIN :Extended;
const
ZERO :Real = 0.0;
DZERO :Real = 0.0e0;
ONE :Real = 1.0;
TWO :Real = 2.0;
label
_10,_11,_12,_13,_20,_21,_22,_23,_24,_25,_26,_27,_28,_29,_40,_41,_42,
_43,_44,_45,_46,_47,_48,_49,_50,_51,_52,_60,_61,_62,_63,_70;
begin
{ ****************************************************C }
{        :                  C }
{               D(M,N)=Q(M,M)*A(M,N)*R(N,N)           C }
{      Q=QN*..*Q1  R=R1*..*RN- . C }
{      D-   .           C }
{ ****************************************************C }
RNORM := ZERO;
if ( M < N ) or ( N <= 2 ) 
 then goto _62;
RMIN := ONE;
_10:
RMIN := RMIN/TWO;
if ( ONE < (ONE+RMIN) ) and ( RMIN > ZERO ) 
 then goto _10;
DMIN := IntPower(RMIN,2);
DS1 := DZERO;
DS2 := DZERO;
SUM := ZERO;
ISWTCH := 1;
R5 := ZERO;
for I:=1 to M do
 begin
  for J:=1 to N do
   begin
    R6 := Abs(A[(I-1)+(J-1)*M]);
    if ( R6 > R5 ) 
     then R5 := R6;
_11:
   end;
 end;
RNORM := ONE;
if ( R5 = ZERO ) 
 then exit;
if ( ((R5*RMIN)/128.0)*128.0*RMIN > ZERO ) 
 then goto _13;
if ( R5 > ONE ) 
 then goto _13;
if ( (R5/128.0) = ZERO ) 
 then R5 := R5*128.0;
ISWTCH := (Trunc(-Ln(R5)/Ln(TWO))+1) div 2;
RNORM := IntPower(TWO,ISWTCH);
for I:=1 to M do
 begin
  for J:=1 to N do
   begin
    A[(I-1)+(J-1)*M] := (A[(I-1)+(J-1)*M]*RNORM)*RNORM;
_12:
   end;
 end;
_13:
JJ := 1;
JN := 2;
C[N-1] := ZERO;
_20:
RD2 := DZERO;
for K:=JJ to M do
 begin
  RD := A[(K-1)+(JJ-1)*M];
_21:
  RD2 := RD2+RD*RD;
 end;
_22:
R2 := RD2;
DS1 := DS1+RD2;
DS2 := DS2-RD2;
J := JJ;
JJ := JN;
JN := JJ+1;
if ( DS2 < DMIN*DS1 ) and ( ISWTCH < 0 ) 
 then goto _60;
R4 := DS1;
R4 := (RMIN*R4)*RMIN;
if ( R2 > R4 ) or ( ISWTCH < 0 ) 
 then goto _24;
SUM := R2;
for I1:=J to M do
 begin
  for J1:=JJ to N do
   begin
_23:
    SUM := SUM+IntPower(A[(I1-1)+(J1-1)*M],2);
   end;
 end;
DS2 := SUM;
ISWTCH := -1;
if ( DS2 <= DMIN*DS1 ) 
 then goto _60;
_24:
R1 := A[(J-1)+(J-1)*M];
R3 := Sign(Sqrt(R2),R1);
B[J-1] := -R3;
L := JJ-N;
if ( R2 ) < 0
 then goto _62
 else if ( R2 ) > 0
       then goto _25
       else goto _41;
_25:
R1 := Sqrt(ONE+R1/R3);
R2 := ONE/(R3*R1);
A[(J-1)+(J-1)*M] := R1;
for I:=JJ to M do
 begin
_26:
  A[(I-1)+(J-1)*M] := A[(I-1)+(J-1)*M]*R2;
 end;
if ( L ) < 0
 then goto _27
 else if ( L ) > 0
       then goto _62
       else goto _27;
_27:
RD2 := DZERO;
for K:=JJ to N do
 begin
  R3 := ZERO;
  for I:=J to M do
   begin
_28:
    R3 := R3+A[(I-1)+(J-1)*M]*A[(I-1)+(K-1)*M];
   end;
  R2 := A[(J-1)+(K-1)*M]-R1*R3;
  A[(J-1)+(K-1)*M] := R2;
  RD := R2;
  RD2 := RD2+RD*R2;
  for I:=JJ to M do
   begin
_29:
    A[(I-1)+(K-1)*M] := A[(I-1)+(K-1)*M]-R3*A[(I-1)+(J-1)*M];
   end;
 end;
_40:
if ( L ) < 0
 then goto _46
 else if ( L ) > 0
       then goto _62
       else goto _43;
_41:
for II:=J to M do
 begin
_42:
  A[(II-1)+(J-1)*M] := ZERO;
 end;
if ( L ) < 0
 then goto _44
 else if ( L ) > 0
       then goto _62
       else goto _43;
_43:
R3 := A[(N-2)+(N-1)*M];
R4 := DS1;
R4 := (RMIN*R4)*RMIN;
R3 := R3*R3;
if ( R3 <= R4 ) and ( M <= N ) 
 then A[(N-2)+(N-1)*M] := ZERO;
R3 := A[(N-1)+(N-1)*M];
R3 := R3*R3;
if ( R3 <= R4 ) and ( M <= N ) 
 then A[(N-1)+(N-1)*M] := ZERO;
C[N-2] := A[(N-2)+(N-1)*M];
B[N-1] := A[(N-1)+(N-1)*M];
if ( M-N ) < 0
 then goto _62
 else if ( M-N ) > 0
       then goto _20
       else goto _62;
_44:
RD2 := DZERO;
for K:=JJ to N do
 begin
  RD := A[(J-1)+(K-1)*M];
_45:
  RD2 := RD2+RD*RD;
 end;
_46:
R2 := RD2;
DS1 := DS1+RD2;
DS2 := DS2-RD2;
R1 := A[(J-1)+(JJ-1)*M];
R3 := Sign(Sqrt(R2),R1);
C[J-1] := -R3;
if ( R2 ) < 0
 then goto _62
 else if ( R2 ) > 0
       then goto _49
       else goto _47;
_47:
for II:=JJ to N do
 begin
_48:
  A[(J-1)+(II-1)*M] := ZERO;
 end;
goto _20;
_49:
R1 := Sqrt(ONE+R1/R3);
R2 := ONE/(R3*R1);
A[(J-1)+(JJ-1)*M] := R1;
for K:=JN to N do
 begin
_50:
  A[(J-1)+(K-1)*M] := A[(J-1)+(K-1)*M]*R2;
 end;
RD2 := DZERO;
for I:=JJ to M do
 begin
  R3 := ZERO;
  for K:=JJ to N do
   begin
_51:
    R3 := R3+A[(J-1)+(K-1)*M]*A[(I-1)+(K-1)*M];
   end;
  R2 := A[(I-1)+(JJ-1)*M]-R1*R3;
  A[(I-1)+(JJ-1)*M] := R2;
  RD := R2;
  RD2 := RD2+RD*R2;
  for K:=JN to N do
   begin
_52:
    A[(I-1)+(K-1)*M] := A[(I-1)+(K-1)*M]-R3*A[(J-1)+(K-1)*M];
   end;
 end;
goto _22;
_60:
for J1:=J to N do
 begin
  B[J1-1] := ZERO;
  C[J1-1] := ZERO;
  for I1:=J to M do
   begin
_61:
    A[(I1-1)+(J1-1)*M] := ZERO;
   end;
 end;
_62:
if ( RNORM = ONE ) 
 then goto _70;
RNORM := ONE/RNORM;
for J:=1 to N do
 begin
  B[J-1] := (B[J-1]*RNORM)*RNORM;
  C[J-1] := (C[J-1]*RNORM)*RNORM;
_63:
 end;
_70:
end;

end.
