Unit ALS1R3_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc;

procedure ALS1R3(var B :Array of Real; var C :Array of Real;
                M :Integer; N :Integer; Q :Real; var F :Array of Real;
                var U :Array of Real; var H :Array of Real;
                var V :Array of Real; var W :Array of Real;
                var W1 :Array of Real);

implementation

procedure ALS1R3(var B :Array of Real; var C :Array of Real;
                M :Integer; N :Integer; Q :Real; var F :Array of Real;
                var U :Array of Real; var H :Array of Real;
                var V :Array of Real; var W :Array of Real;
                var W1 :Array of Real);
var
I,J,K,L,L1 :Integer;
R,R1,R2,T,T1,T2,S,S1,S2,S3,S5 :Real;
const
ZERO :Real = 0.0;
label
_10,_11,_12,_13,_14,_15,_16,_17,_18,_19,_20;
begin
{ ****************************************************C }
{         (D'*D+Q*E)*U=D'*F            C }
{         .      C }
{ ****************************************************C }
if ( M < N ) or ( N <= 2 ) or ( Q < ZERO ) 
 then exit;
S := ZERO;
L := N+1;
_10:
L := L-1;
R := C[L-2];
if ( B[L-1] = S ) and ( R = S ) and ( L > 3 ) 
 then goto _10;
L1 := L+1;
if ( L-M ) < 0
 then goto _11
 else if ( L-M ) > 0
       then goto _20
       else goto _13;
_11:
for I:=L1 to M do
 begin
  T1 := F[I-1];
_12:
  S := S+T1*T1;
 end;
_13:
T := B[0];
R := EMax1(Sqrt(Q+T*T),Abs(T));
V[0] := R;
T2 := C[0];
R2 := T2*(T/R);
W[0] := R2;
S2 := F[0];
R1 := T*S2/R;
U[0] := R1;
S5 := S2*S2;
for I:=2 to L do
 begin
  T := B[I-1];
  T1 := T2;
  T2 := C[I-1];
  S1 := S2;
  S2 := F[I-1];
  R := EMax1(ZERO,(T1-R2)*(T1+R2));
  R := EMax1(Sqrt(T*T+R+Q),Abs(T));
  R1 := (T*S2+T1*S1-R1*R2)/R;
  U[I-1] := R1;
  V[I-1] := R;
  R2 := T2*(T/R);
  W[I-1] := R2;
_14:
  S5 := S5+S2*S2;
 end;
R2 := Sqrt(Q);
if ( L1 > N ) 
 then goto _16;
for I:=L1 to N do
 begin
  U[I-1] := ZERO;
  V[I-1] := R2;
  W[I-1] := ZERO;
_15:
  W1[I-1] := ZERO;
 end;
_16:
R := R1/R;
U[L-1] := R;
R2 := R*T-S2;
S1 := R2*R2;
S3 := R*R;
for I:=2 to L do
 begin
  J := L1-I;
  R1 := R;
  R := (U[J-1]-R*W[J-1])/V[J-1];
  U[J-1] := R;
  R2 := R*B[J-1]+R1*C[J-1];
  R2 := R2-F[J-1];
  S1 := S1+R2*R2;
_17:
  S3 := S3+R*R;
 end;
R := Q*R/V[0];
W1[0] := R;
for K:=2 to L do
 begin
  R := (Q*U[K-1]-R*W[K-2])/V[K-1];
_18:
  W1[K-1] := R;
 end;
R := R/V[L-1];
W1[L-1] := R;
S2 := R*R;
for I:=2 to L do
 begin
  J := L1-I;
  R := (W1[J-1]-R*W[J-1])/V[J-1];
  W1[J-1] := R;
  S2 := S2+R*R;
  R1 := (W1[J+0]+U[J+0])*W[J-1];
_19:
 end;
{ ----------------------------------------------------C }
{         :      C }
{       H(1)  = !!D*U-F!!   -   .              C }
{       H(2)  = Q*!!!U'!!!  -   .     C }
{       H(3)  = !!!U!!!     -   . .    C }
{       H(4)  = !!D*U-F!!**2+Q*!!!U!!!**2             C }
{       H(5)  = Q      -    .    C }
{       H(6)  = !!D*U-F!!/!!F!! -  .    C }
{ ----------------------------------------------------C }
H[0] := Sqrt(S1+S);
H[1] := Sqrt(S2);
H[2] := Sqrt(S3);
H[3] := S1+S+Q*S3;
H[4] := Q;
H[5] := H[0]/Sqrt(S5+S);
_20:
end;

end.
