Unit ALS1R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, ALS1R1_p, ALS1R2_p, ALS1R3_p, ALS1R4_p;

procedure ALS1R(var A :Array of Real; var U :Array of Real;
                var F :Array of Real; M :Integer; N :Integer;
                EPS :Real; var H :Array of Real; var W :Array of Real;
                L :Integer);

implementation

procedure ALS1R(var A :Array of Real; var U :Array of Real;
                var F :Array of Real; M :Integer; N :Integer;
                EPS :Real; var H :Array of Real; var W :Array of Real;
                L :Integer);
var
I,NITER,NIT,IEXIT :Integer;
RMIN1,RMIN,F1,R,SR,S,RR,HH,QQ,Q,H1 :Real;
label
_1,_2,_3,_4,_5,_6,_7,_8,_9,_10;
begin
RMIN1 := 1.0;
case L of
 1: goto _1;
 2: goto _3;
 3: goto _2;
end;
_1:
RMIN := RMIN1;
RMIN1 := RMIN/2.0;
if ( RMIN1 > 0.0 ) 
 then goto _1;
ALS1R1(A,M,N,W,W[0+1*N]);
W[(N-1)+1*N] := RMIN;
_2:
ALS1R2(A,M,N,F);
_3:
RMIN := W[(N-1)+1*N];
RMIN1 := 16*RMIN;
F1 := F[0];
R := F1*F1;
for I:=2 to N do
 begin
  F1 := F[I-1];
_4:
  R := R+F1*F1;
 end;
SR := Sqrt(R);
S := IntPower(F[0]*W[0+0*N]/SR,2);
for I:=2 to N do
 begin
  F1 := F[I-1];
_5:
  S := S+IntPower((W[(I-1)+0*N]*F1+W[(I-2)+1*N]*F[I-2])/SR,2);
 end;
RR := SR*EPS;
H[0] := SR;
H[1] := 0.0;
H[2] := 0.0;
H[3] := R;
H[4] := 1.E+20;
H[5] := 1.0;
H[6] := 0.0;
NITER := 0;
NIT := 0;
IEXIT := -1;
HH := SR;
QQ := H[4];
for I:=1 to N do
 begin
_6:
  U[I-1] := 0.0;
 end;
if ( EPS >= 1.0 ) 
 then exit;
Q := (EPS/(1.0-EPS))*S;
if ( Q = 0.0 ) 
 then Q := RMIN;
_7:
ALS1R3(W,W[0+1*N],M,N,Q,F,U,H,W[0+2*N],W[0+3*N],W[0+4*N]);
H1 := H[0];
NITER := NITER+1;
if ( IEXIT = 1 )
 then goto _10;
if ( HH >= H1 ) 
 then goto _8;
IEXIT := 1;
Q := QQ;
goto _7;
_8:
if ( RR*1.001 >= H1 ) 
 then goto _10;
if ( Q <= RMIN1 ) 
 then goto _10;
HH := H1;
QQ := Q;
S := 0.0;
for I:=1 to N do
 begin
_9:
  S := S+U[I-1]*Q*W[(I-1)+4*N];
 end;
if ( S = 0.0 ) 
 then S := 4.0*RMIN1;
R := (H1/RR-1.0)*H1*(H1/S);
if ( R <= 0.5 ) 
 then NIT := NIT+1;
if ( R <= 0.5 ) and ( H[5] >= 10.0 ) and ( NIT > 5 ) 
 then R := 1.0;
Q := Q/(1.0+R);
if ( Q = 0.0 ) 
 then Q := RMIN;
goto _7;
_10:
ALS1R4(A,M,N,U);
H[6] := NITER;
W[(N-1)+1*N] := RMIN;
end;

end.
